Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0004981OCamlOCamlbuild (the tool)public2010-02-17 15:222013-08-01 11:01
Reportersamin 
Assigned Toxclerc 
PrioritynormalSeverityfeatureReproducibilityalways
StatusresolvedResolutionsuspended 
PlatformOSOS Version
Product Version3.11.2 
Target VersionFixed in Version 
Summary0004981: ocamlbuild/my_std.ml shouldn't call bash
DescriptionOn a vanilla Windows machine, with no cygwin, ocamlbuild falls over.

ocamlbuild calls bash.
But the presence of ocaml Windows distributions implies that I need not have bash on my os.
TagsNo tags attached.
Attached Files

- Relationships
related to 0006107acknowledged Lack of quoting helpers for use with Unix.open_process* 
related to 0006096acknowledged Validate what is needed to fully support Windows 
related to 0005201feedback Performance issue for ocamlbuild on Windows 

-  Notes
(0005330)
xleroy (administrator)
2010-04-18 19:00

As far as I can remember Windows's standard command-line interpreter (cmd.exe) is unusable in ocamlbuild's context (and in many others), because of its incomplete (and undocumented!) quoting behavior: there are plenty of commands that simply cannot be given as argument to "cmd /c" because they cannot be quoted properly. So, that leave little choice but going through a better shell like Cygwin's. Suggestions for alternative approaches most welcome. (Reclassified as "feature wish".)
(0005371)
samin (reporter)
2010-04-26 13:10

I'm OK with this being reclassified as a feature wish.
Can you point me to the examples of what can't be run using Sys.command on Windows?
(0005374)
ertai (developer)
2010-04-26 13:41

I don't rember exactly the examples but try to pass an argument to a command that contains spaces, quotes, slashes, blackslashes and you will quickly found the problem.
(0005375)
Julien Signoles (reporter)
2010-04-26 13:43

Bashisms are also an issue for BSD-like systems: that is not a Windows-only feature wish.
(0005377)
ertai (developer)
2010-04-26 14:17

Bashism is only when you call sh, here we call bash.
(0006722)
protz (manager)
2012-01-18 11:18

Hi,

First of all, thanks for reporting. While we believe you're
making a valid point, we don't have enough manpower to devote to this feature in
the foreseeable future. We're moving this to the resolved/suspended status: this
means the discussion is still open, but the PR won't appear in our to-do list.
You're welcome to reopen the issue if you have a patch; we would gladly review
it.

Thanks,

jonathan
(0007472)
ygrek (reporter)
2012-05-30 15:37

A description of windows quoting rules, including cmd.
http://blogs.msdn.com/b/twistylittlepassagesallalike/archive/2011/04/23/everyone-quotes-arguments-the-wrong-way.aspx [^]
(0007473)
protz (manager)
2012-05-30 15:55

The next version of the Windows installer will encourage the user to install Cygwin. A few bugs have been fixed as well, and now ocamlbuild calls bash with what we believe is proper quoting. This should be announced in a few days, once we package the beta release of OCaml 4.00.

The official position is now: "if you want to get an ocaml development environment under Windows, just install cygwin". The windows installer will offer you the option of launching cygwin's setup.exe with the right set of packages preselected.

But of course we'd be glad to accept a patch that lifts the requirement on bash on Windows. That being said, I don't think anyone here wants to be the person who writes the patch :).

Thanks,

jonathan

- Issue History
Date Modified Username Field Change
2010-02-17 15:22 samin New Issue
2010-04-18 19:00 xleroy Note Added: 0005330
2010-04-18 19:00 xleroy Assigned To => ertai
2010-04-18 19:00 xleroy Severity major => feature
2010-04-18 19:00 xleroy Status new => feedback
2010-04-26 13:10 samin Note Added: 0005371
2010-04-26 13:41 ertai Note Added: 0005374
2010-04-26 13:43 Julien Signoles Note Added: 0005375
2010-04-26 14:17 ertai Note Added: 0005377
2010-07-22 11:41 ertai Status feedback => assigned
2010-07-22 11:41 ertai Assigned To ertai => xclerc
2012-01-18 11:18 protz Note Added: 0006722
2012-01-18 11:18 protz Status assigned => resolved
2012-01-18 11:18 protz Resolution open => suspended
2012-02-02 15:17 protz Category OCamlbuild => OCamlbuild (the tool)
2012-05-30 15:37 ygrek Note Added: 0007472
2012-05-30 15:55 protz Note Added: 0007473
2013-07-27 08:52 protz Relationship added related to 0006096
2013-07-28 23:19 gasche Relationship added related to 0005201
2013-08-01 11:01 xleroy Relationship added related to 0006107


Copyright © 2000 - 2011 MantisBT Group
Powered by Mantis Bugtracker